import { Program } from "@project-serum/anchor";
import { PublicKey, AccountMeta } from "@solana/web3.js";
import BN from "bn.js";
import { PropeasyProgram } from "../artifacts/propeasy_program";
import { Instruction } from "@orca-so/common-sdk";
export type PurchasePropertyTokenParams = {
    accounts: {
        user: PublicKey;
        platformState: PublicKey;
        platformMintAccount: PublicKey;
        userPlatformTokenAccount: PublicKey;
        platformVaultTokenAccount: PublicKey;
        admin: PublicKey;
        adminPurchaseTokenAccount: PublicKey;
        purchaseMintAccount: PublicKey;
        userPurchaseTokenAccount: PublicKey;
        propertyState: PublicKey;
        propertyMintAccount: PublicKey;
        lockerAccount: PublicKey;
        vestingAccount: PublicKey;
    };
    remainingAccounts?: AccountMeta[];
    inputs: {
        purchaseAmount: BN;
    };
};
export declare function purchasePropertyToken(program: Program<PropeasyProgram>, params: PurchasePropertyTokenParams): Promise<Instruction>;
