/// <reference types="bn.js" />
import { Instruction } from "@orca-so/common-sdk";
import { PublicKey } from "@solana/web3.js";
import { Program, BN } from "@project-serum/anchor";
import { PropeasyProgram } from "../artifacts/propeasy_program";
export type UpdatePropertyParams = {
    accounts: {
        admin: PublicKey;
        platformState: PublicKey;
        propertyState: PublicKey;
        propertyMintAccount: PublicKey;
    };
    inputs: {
        privateSaleStartTime: BN;
        privateSaleEndTime: BN;
        privateSaleSupplyAmount: BN;
        privateSaleTokenPrice: BN;
        privateSaleMinimumPurchaseAmount: BN;
        privateSaleCommissionAmount: BN;
        privateSaleReferralCommissionAmount: BN;
        privateSaleDiscountPercentage: number;
        privateSaleTgePercentage: number;
        privateSaleUnlockPeriod: BN;
        privateSaleUnlockDuration: BN;
        privateSaleMinimumPlatformAmount: BN;
        publicSaleStartTime: BN;
        publicSaleEndTime: BN;
        publicSaleSupplyAmount: BN;
        publicSaleTokenPrice: BN;
        publicSaleMinimumPurchaseAmount: BN;
        publicSaleCommissionAmount: BN;
        publicSaleCommissionBoostAmount: BN;
        publicSaleReferralCommissionAmount: BN;
        publicSaleReferralCommissionBoostAmount: BN;
        publicSaleReferralCommissionBoostThreshold: BN;
    };
};
export declare function updateProperty(program: Program<PropeasyProgram>, params: UpdatePropertyParams): Promise<Instruction>;
