/// <reference types="bn.js" />
import { Instruction } from "@orca-so/common-sdk";
import { PublicKey } from "@solana/web3.js";
import { Program, BN } from "@project-serum/anchor";
import { PropeasyProgram } from "../artifacts/propeasy_program";
export type WithdrawPlatformTokenParams = {
    accounts: {
        admin: PublicKey;
        platformState: PublicKey;
        platformMintAccount: PublicKey;
        propertyState: PublicKey;
        platformVaultTokenAccount: PublicKey;
        propertyMintAccount: PublicKey;
        beneficiaryPlatformTokenAccount: PublicKey;
    };
    inputs: {
        beneficiary: PublicKey;
        amount: BN;
    };
};
export declare function withdrawPlatformToken(program: Program<PropeasyProgram>, params: WithdrawPlatformTokenParams): Promise<Instruction>;
